VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Kugelsimulation"
   ClientHeight    =   5235
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6495
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5235
   ScaleWidth      =   6495
   StartUpPosition =   3  'Windows-Standard
   Begin VB.HScrollBar HScroll2 
      Height          =   255
      Left            =   100
      Min             =   1
      TabIndex        =   3
      Top             =   120
      Value           =   16000
      Width           =   2295
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      Left            =   120
      Max             =   180
      TabIndex        =   2
      Top             =   4800
      Width           =   4215
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   4215
      Left            =   4440
      Max             =   180
      TabIndex        =   1
      Top             =   480
      Width           =   255
   End
   Begin VB.PictureBox Picture1 
      Height          =   4215
      Left            =   120
      ScaleHeight     =   277
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   277
      TabIndex        =   0
      Top             =   480
      Width           =   4215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

Const Pi As Double = 3.14159265358979

Function Atann(x, y) As Double
    Dim alpha As Double
    Dim atan As Double
    
    If x <> 0 Then
        atan = Atn(Abs(y) / Abs(x))
    Else
        atan = 0
    End If
    
    Select Case x
        Case Is > 0
            If y >= 0 Then
                ' 1st quad
                alpha = atan
            Else
                ' 4th quad
                alpha = 2 * Pi - atan
            End If
        
        Case Is < 0
            If y >= 0 Then
                ' 2nd quad
                alpha = Pi - atan
            Else
                ' 3rd quad
                alpha = atan + Pi
            End If
        
        Case Is = 0
           Select Case y
            Case Is > 0
                ' 1st
                alpha = Pi / 2
            Case Is < 0
                ' 3rd
                alpha = 3 * Pi / 2
            Case Is = 0
                alpha = 0
            End Select
    End Select

'us_atann:
    Atann = alpha - Pi / 2
    Atann = Atann / Pi * 180
    Atann = (Atann + 180) Mod 360
End Function




Private Sub paintball(radius As Double, coX As Double, coY As Double, _
    lightpitch As Double, lightyaw As Double, _
    dotrad As Double, pic As PictureBox, _
    r As Byte, g As Byte, b As Byte)
    
'radius:              Der Radius der Kugel
'coX,coY:             Der Mittelpunkt der Kugel
'lightpitch,lightyaw: Der Winkel des Lichts (0 bin 360)
'dotrad:              Der radius des hellen punktes auf der Kugel (0 bis 1)
'pic:                 Die Picturebox auf die gezeichent werden soll.
'                         Auchtung: Scalemode muss vbPixel sein.
'r,g,b:               Die Farbe der Kugel

    'Wie stark die Kugel glnzen soll (0-255)
    Const glanz = 64
    pic.Cls
    
    Dim x As Long, y As Long
    Dim degrees As Double, z As Double
    Dim color As Double, z2 As Double
    Dim brightnessA As Double, brightnessB As Double
    Dim brightnessc As Double
    Dim dx As Double, dy As Double
    Dim dz As Double
    
    For x = -radius To radius
        For y = -radius To radius
            z2 = Sqr(x * x + y * y)
            If z2 < radius Then
                degrees = Atann(x, y)
                z = Sqr(1 - (z2 / radius) ^ 2)
                dz = degrees
                dx = Atann(z * radius, x)
                dy = Atann(z * radius, y)
                color = similardeg(dx, lightyaw, dy, lightpitch)
                color = color - (1 - dotrad)
                color = color / dotrad / 2
                If color < 0 Then color = 0
                color = color * 2
                color = RGB(color * (r + glanz) + color + r / 2, _
                            color * (g + glanz) + color + g / 2, _
                            color * (b + glanz) + color + b / 2)
                    
                'color = RGB(z * 255, 0, 0)
                pic.PSet (coX + x - radius, coY + y - radius), color
            End If
        Next y
    Next x
    
    'sonne malen
    x = -Cos(lightyaw / 180 * Pi) * 2 * radius
    y = -Cos(lightpitch / 180 * Pi) * 2 * radius
    pic.DrawWidth = 10
    pic.PSet (coX + x - radius, coY + y - radius), RGB(255, 255, 0)
    pic.DrawWidth = 1
End Sub

Private Function similardeg(p1 As Double, p2 As Double, _
    p3 As Double, p4 As Double) As Double
    
    'diese Funktion prft, ob die Ausrichtung von 2 Graden hlich ist.
    'Alle Graden werden in winkeln angegeben.
    similardeg = 360 - Sqr((p1 - p2) ^ 2 + (p3 - p4) ^ 2)
    similardeg = similardeg / 360
End Function

Private Function arcussinus(x As Double) As Double
    arcussinus = Atn(x / Sqr(-x * x + 1)) / Pi * 180
End Function

Private Sub Form_Paint()
    HScroll1_Change
End Sub

Private Sub HScroll1_Change()
    paintball 50, 200, 200, VScroll1.Value, HScroll1.Value, _
        HScroll2.Value / 32767, Picture1, 64, 128, 192
End Sub

Private Sub HScroll2_Change()
    HScroll1_Change
End Sub

Private Sub VScroll1_Change()
    HScroll1_Change
End Sub
